package example.codes;

import java.util.Locale;

import org.joda.time.LocalDateTime;

import com.silanis.esl.sdk.*;
import com.silanis.esl.sdk.builder.*;

public class PackageManagement {
	
    public static final String OLD_LOGO_IMAGE_LINK = "old logo image link";
    public static final String OLD_LOGO_IMAGE_SOURCE = "old logo image source";

    public static final String OLD_DECLINE_REASON_1 = "old decline reason #1";
    public static final String OLD_DECLINE_REASON_2 = "old decline reason #2";
    public static final String OLD_DECLINE_REASON_3 = "old decline reason #3";

    public static final String OLD_HAND_OVER_LINK_HREF = "http://www.old.ca";
    public static final String OLD_HAND_OVER_LINK_TEXT = "old hand over link text";
    public static final String OLD_HAND_OVER_LINK_TOOL_TIP = "old hand over link tool tip";

    public static final String OLD_OPT_OUT_REASON_1 = "old opt out reason #1";
    public static final String OLD_OPT_OUT_REASON_2 = "old opt out reason #2";
    public static final String OLD_OPT_OUT_REASON_3 = "old opt out reason #3";

    public static final String OLD_PACKAGE_NAME = "Old Package Name";
    public static final String OLD_DESCRIPTION = "Old Description";
    public static final String OLD_EMAIL_MESSAGE = "Old Email Message";

    // Visibility is for only template
    public static final Visibility OLD_VISIBILITY = Visibility.ACCOUNT;
    public static final boolean OLD_NOTARIZED = false;

    public static final String NEW_LOGO_IMAGE_LINK = "new logo image link";
    public static final String NEW_LOGO_IMAGE_SOURCE = "new logo image source";

    public static final String NEW_DECLINE_REASON_1 = "new decline reason #1";
    public static final String NEW_DECLINE_REASON_2 = "new decline reason #2";
    public static final String NEW_DECLINE_REASON_3 = "new decline reason #3";

    public static final String NEW_HAND_OVER_LINK_HREF = "http://www.new.ca";
    public static final String NEW_HAND_OVER_LINK_TEXT = "new hand over link text";
    public static final String NEW_HAND_OVER_LINK_TOOL_TIP = "new hand over link tool tip";

    public static final String NEW_OPT_OUT_REASON_1 = "new opt out reason #1";
    public static final String NEW_OPT_OUT_REASON_2 = "new opt out reason #2";
    public static final String NEW_OPT_OUT_REASON_3 = "new opt out reason #3";

    public static final String NEW_PACKAGE_NAME = "new package name";
    public static final String NEW_DESCRIPTION = "new description";
    public static final String NEW_EMAIL_MESSAGE = "new email message";
    public static final Visibility NEW_VISIBILITY = Visibility.SENDER;
    public static final boolean NEW_NOTARIZED = true;

    public CeremonyLayoutSettings layoutSettingsToCreate, createdLayoutSettings, layoutSettingsToUpdate, updatedLayoutSettings;
    public DocumentPackageSettings settingsToCreate, createdSettings, settingsToUpdate, updatedSettings;
    public DocumentPackage packageToCreate, createdPackage, packageToUpdate, updatedPackage;
    
    public static final String email1 = "mail32@mailinator.com";

	public static void main(String[] args) {
		
		  EslClient eslClient = new EslClient(MyInfo.API_KEY_SANDBOX, MyInfo.API_URL_SANDBOX);
		  
		  //Retrieve package
	      PackageId packageId = new PackageId("package_id_here");
	      DocumentPackage retrievedPkg = eslClient.getPackage(packageId);
	      
	      //Update package
	      CeremonyLayoutSettings layoutSettingsToUpdate = CeremonyLayoutSettingsBuilder.newCeremonyLayoutSettings()
	           .withoutBreadCrumbs()
	           .withoutGlobalConfirmButton()
	           .withoutGlobalDownloadButton()
	           .withoutGlobalNavigation()
	           .withoutGlobalSaveAsLayoutButton()
	           .withLogoLink(NEW_LOGO_IMAGE_LINK)
	           .withLogoSource(NEW_LOGO_IMAGE_SOURCE)
	           .withoutNavigator()
	           .withoutProgressBar()
	           .withoutSessionBar()
	           .withoutTitle()
	           .build();
	
	      DocumentPackageSettings settingsToUpdate = DocumentPackageSettingsBuilder.newDocumentPackageSettings()
	          .withoutCaptureText()
	          .withDecline()
	          .withDeclineReason(NEW_DECLINE_REASON_1)
	          .withDeclineReason(NEW_DECLINE_REASON_2)
	          .withDeclineReason(NEW_DECLINE_REASON_3)
	          .withoutDialogOnComplete()
	          .withoutDocumentToolbarDownloadButton()
	          .withHandOverLinkHref(NEW_HAND_OVER_LINK_HREF)
	          .withHandOverLinkText(NEW_HAND_OVER_LINK_TEXT)
	          .withHandOverLinkTooltip(NEW_HAND_OVER_LINK_TOOL_TIP)
	          .withoutInPerson()
	          .withoutOptOut()
	          .withOptOutReason(NEW_OPT_OUT_REASON_1)
	          .withOptOutReason(NEW_OPT_OUT_REASON_2)
	          .withOptOutReason(NEW_OPT_OUT_REASON_3)
	          .withoutWatermark()
	          .withCeremonyLayoutSettings(layoutSettingsToUpdate)
	          .build();
	
	      DocumentPackage packageToUpdate = PackageBuilder.newPackageNamed(NEW_PACKAGE_NAME)
	              .describedAs(NEW_DESCRIPTION)
	              .withEmailMessage(NEW_EMAIL_MESSAGE)
	              .expiresAt(LocalDateTime.now().toDate())
	              .withLanguage(Locale.FRENCH)
	              .withVisibility(NEW_VISIBILITY)
	              .withNotarized(NEW_NOTARIZED)
	              .autocomplete(false)
	              .withSettings(settingsToUpdate)
	              .build();
	
	      eslClient.updatePackage(packageId, packageToUpdate);
		
	      //delete package
	      eslClient.getPackageService().deletePackage(packageId);
	}

}

